var request = require('request');
var async = require('async');
var consolestore = require('consolestore');

module.exports = {
    curl: function(url, controle_url, callback_curl){

        consolestore.log('Trying curl on : '+url, function(err, res){});

        async.waterfall([
            function(callback)
            {
                if(controle_url)
                {
                    consolestore.log('Controling url : '+url, function(err, res){});
                    controle_url(url, callback);
                }
                else
                {
                    callback(null, true);
                }
            },
            function(go, callback) {

                if(go)
                {
                    var sleeps = [];
                    sleeps.push(0.9);
                    sleeps.push(1.8);
                    sleeps.push(1.8);
                    sleeps.push(1.2);
                    sleeps.push(1.6);
                    sleeps.push(3.6);
                    sleeps.push(2.9);
                    sleeps.push(0.95);
                    sleeps.push(1.55);
                    sleeps.push(2.1);
                    sleeps.push(1.7);
                    sleeps.push(1.5);
                    sleeps.push(1.7);

                    var user_agents = [];
                    user_agents.push("Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:36.0) Gecko/20100101 Firefox/36.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; WOW64; rv:33.0) Gecko/20100101 Firefox/33.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; rv:15.0) Gecko/20120716 Firefox/15.0a2");
                    user_agents.push("Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; ko; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2");
                    user_agents.push("Mozilla/5.0 (Windows; U; Windows NT 5.0; it-IT; rv:1.7.12) Gecko/20050915");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/27.0.1453.12 Safari/537.36 OPR/14.0.1116.4");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/28.0.1500.29 Safari/537.36 OPR/15.0.1147.24 (Edition Next)");
                    user_agents.push("Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/532.0 (KHTML, like Gecko) Chrome/3.0.195.27 Safari/532.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1599.101 Safari/537.36");
                    user_agents.push("Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; ko; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; WOW64; rv:33.0) Gecko/20100101 Firefox/33.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1599.101 Safari/537.36");
                    user_agents.push("Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:36.0) Gecko/20100101 Firefox/36.0");
                    user_agents.push("Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; ko; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2");

                    var random_index = Math.floor((Math.random() * 10));
                    var user_agent = user_agents[random_index];
                    var selected_time = sleeps[random_index];



                    setTimeout(function(){
                        request(url, {headers: {
                            "User-Agent": user_agent
                        }}, function (error, response, html)
                        {
                            if(error)
                            {
                                callback(null,{html: false, url: url});
                            }
                            else
                            {
                                callback(null,{html: html, url: url});
                            }
                        });
                    },1000*selected_time);
                }
                else
                {
                    consolestore.log('Url Already parsed : '+url, function(err, res){});
                    callback(null,{html: null, url: url});
                }
            }
        ], function (err, result) {

            if(result.html)
            {
                consolestore.log('Curl success on url : '+url, function(err, res){});
            }

            callback_curl(null, result);
        });
    },
    curl_direct: function(url, controle_url, callback_curl){

        consolestore.log('Trying curl on : '+url, function(err, res){});

        async.waterfall([
            function(callback) {
                    var user_agents = [];
                    user_agents.push("Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:36.0) Gecko/20100101 Firefox/36.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; WOW64; rv:33.0) Gecko/20100101 Firefox/33.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; rv:15.0) Gecko/20120716 Firefox/15.0a2");
                    user_agents.push("Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; ko; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2");
                    user_agents.push("Mozilla/5.0 (Windows; U; Windows NT 5.0; it-IT; rv:1.7.12) Gecko/20050915");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/27.0.1453.12 Safari/537.36 OPR/14.0.1116.4");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/28.0.1500.29 Safari/537.36 OPR/15.0.1147.24 (Edition Next)");
                    user_agents.push("Mozilla/5.0 (Windows; U; Windows NT 5.2; en-US) AppleWebKit/532.0 (KHTML, like Gecko) Chrome/3.0.195.27 Safari/532.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1599.101 Safari/537.36");
                    user_agents.push("Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; ko; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.1; WOW64; rv:33.0) Gecko/20100101 Firefox/33.0");
                    user_agents.push("Mozilla/5.0 (Windows NT 6.3; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/30.0.1599.101 Safari/537.36");
                    user_agents.push("Mozilla/5.0 (Macintosh; Intel Mac OS X 10.10; rv:36.0) Gecko/20100101 Firefox/36.0");
                    user_agents.push("Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10.5; ko; rv:1.9.1b2) Gecko/20081201 Firefox/3.1b2");

                    var random_index = Math.floor((Math.random() * 10));
                    var user_agent = user_agents[random_index];

                    setTimeout(function(){
                        request(url, {headers: {
                            "User-Agent": user_agent
                        }}, function (error, response, html)
                        {
                            if(error)
                            {
                                callback(null,{html: false, url: url});
                            }
                            else
                            {
                                callback(null,{html: html, url: url});
                            }
                        });
                    },100);
                }
        ], function (err, result) {

            if(result.html)
            {
                consolestore.log('Curl success on url : '+url, function(err, res){});
            }

            callback_curl(null, result);
        });
    }
};